/*
EVS Aanlevering HiX 6.2 LOGEX 
Versie: 1.0
Auteur: Robin van der Vlies (AskRobin - robin@askrobin.nl)
*/

--Selecteer de gewenste Database
Use HiX_LS

--Selecteer hier uw Zorginstellingscode - Zie onderstaande lijst voor uw ID.
Declare @ID nvarchar(max); Set @ID= '156';
/*
101: Groningen [Universitair Medisch Centrum Groningen]
103: Amsterdam [Academisch Medisch Centrum]
104: Amsterdam [VU Medisch Centrum Amsterdam]
105: Amsterdam [Onze Lieve Vrouwe Gasthuis]
106: Leiden [Leids Universitair Medisch Centrum]
107: Utrecht [UMC Utrecht]
108: Nieuwegein [Sint Antonius Ziekenhuis]
109: Rotterdam [Erasmus Medisch Centrum]
110: Nijmegen [UMC St. Radboud]
111: Breda [Amphia]
112: Eindhoven [Catharina Ziekenhuis Eindhoven]
113: Maastricht [Academisch Ziekenhuis Maastricht]
114: Rotterdam [Sint Franciscus Gasthuis]
116: Lelystad [IJsselmeerziekenhuizen]
117: Zaandam [Zaans Medisch Centrum]
118: Amstelveen [Amstelland Ziekenhuis]
119: Amsterdam [BovenIJ Ziekenhuis]
120: Hoorn [Westfriesgasthuis]
121: Zwolle [Isala Klinieken]
122: Hoofddorp [Spaarne Ziekenhuis]
123: Deventer [Deventer Ziekenhuis]
124: Enschede [Medisch Spectrum Twente]
126: Alkmaar [Medisch Centrum Alkmaar]
127: Tilburg [TweeSteden Ziekenhuis]
128: Arnhem [Rijnstate Ziekenhuis]
129: Amsterdam [Slotervaart Ziekenhuis]
131: Almere [Flevoziekenhuis Almere]
132: Veldhoven [Mxima Medisch Centrum]
133: Oss [Bernhoven Ziekenhuis, locatie Oss]
134: Sittard [Orbis Medisch Centrum]
135: Heerlen [Atrium Medisch Centrum]
136: Leiden [Diaconessenhuis Leiden]
137: Haarlem [Kennemergasthuis Haarlem]
138: Harderwijk [Sint Jansdal Ziekenhuis]
139: Nijmegen [Canisius-Wilhelmina Ziekenhuis]
140: Venlo [VieCuri Medisch Centrum]
142: Boxmeer [Maasziekenhuis]
143: Apeldoorn [Gelre ziekenhuis Apeldoorn]
144: Zutphen [Gelre Ziekenhuis Zutphen]
146: Winterswijk [Streekziekenhuis Koningin Beatrix]
147: Groningen [Martiniziekenhuis]
148: Leeuwarden [Medisch Centrum Leeuwarden]
149: Hoogeveen [Bethesda Ziekenhuis Hoogeveen]
150: Schiedam [Vlietland Ziekenhuis Schiedam/Vlaardingen]
151: Gouda [Groene Hart Ziekenhuis]
152: Den Haag [HagaZiekenhuis]
153: s-Gravenhage [Bronovo]
155: s Hertogenbosch [Jeroen Bosch Ziekenhuis]
156: Dordrecht [Albert Schweitzer Ziekenhuis]
157: Drachten [Nij Smellinghe, Drachten]
158: Woerden [Hofpoort Ziekenhuis]
160: Emmen [Scheperziekenhuis]
162: Sneek [Antonius Ziekenhuis Zuid West Friesland]
163: Roermond [Laurentius Ziekenhuis]
164: Meppel [Diaconessenhuis Meppel]
165: Doetinchem [Slingeland Ziekenhuis]
166: Delft [Reinier de Graaf Groep]
167: Den Haag [Medisch Centrum Haaglanden]
168: Tiel [Ziekenhuis Rivierenland]
169: Heereveen [Tjongerschans Ziekenhuis]
170: Helmond [Elkerliek Ziekenhuis]
171: Purmerend [Waterland Ziekenhuis]
172: Vlissingen [Admiraal de Ruyter Ziekenhuis]
173: Capelle aan de IJssel [IJsselland Ziekenhuis]
175: Amersfoort [Meander Medisch Centrum]
177: Rotterdam [Ikazia Ziekenhuis]
178: Tilburg [St. Elisabeth Ziekenhuis]
179: Assen [Wilhelminaziekenhuis]
180: Winschoten [Ommelander Ziekenhuis Groep - locatie St. Lucas]
181: Gorinchem [Beatrix Ziekenhuis (Rivas Zorggroep)]
182: Hilversum [Tergooi Ziekenhuizen]
183: Delfzijl/Winschoten [Ommelander Ziekenhuis groep]
184: Geldrop [Sint Anna Ziekenhuis]
185: Leiderdorp [Rijnland ziekenhuis]
186: Amsterdam [Sint Lucas Andreas Ziekenhuis]
187: Den Helder [Gemini Ziekenhuis]
189: Dokkum [De Sionsberg]
191: Bergen op Zoom [Lievensberg Ziekenhuis]
192: Beverwijk [Rode Kruis Ziekenhuis]
193: Utrecht [Diakonessenhuis Utrecht]
194: Zoetermeer [LangeLand Ziekenhuis]
195: Roosendaal [Franciscus Ziekenhuis Roosendaal]
196: Ede [Gelderse Vallei]
197: Weert [Sint Jansgasthuis]
199: Hardenberg [Rpcke Zweers Ziekenhuis]
201: Terneuzen [Stichting ZorgSaam Zeeuws Vlaanderen]
202: Rotterdam [Havenziekenhuis]
203: Spijkenisse [Spijkenisse Medisch Centrum]
204: Dirksland [Van Weel Ziekenhuis]
211: Rotterdam [Maasstadziekenhuis Rotterdam]
500: Amsterdam [Antoni van Leeuwenhoek Ziekenhuis]
501: Stadskanaal [Refaja Ziekenhuis Stadskanaal]
502: Zevenaar [Alysis Zorggroep]
504: Curacao [Sint Elisabeth Hospitaal]
505: Hengelo / Almelo [Ziekenhuisgroep Twente]
241: Roosendaal [Bravis Ziekenhuis]
601: Den Haag [Haaglanden Medisch Centrum]
617: Hoofddorp [Spaarne Gasthuis]
618: Alkmaar [Noordwest Ziekenhuisgroep]
807: Heerlen [Zuyderland Medisch Centrum]
1403: Amsterdam [Stichting Onze Lieve Vrouwe Gasthuis]
1561: Apeldoorn [Gelre Ziekenhuizen]
600: Tilburg [Elisabeth TweeSteden Ziekenhuis]
532: Hoogeveen [Treant Zorggroep]
1599: Rotterdam [Franciscus gasthuis en Vlietland]
1633: Zwolle [Stichting Isala Klinieken]
266: Leiderdorp [Alrijne Zorggroep]
30011: Palga"
*/

--Startdatum HiX. Vul hier uw live gang datum HiX in. Als u bijvoorbeeld een EZIS systeem heeft vanaf 20170922 moet u 20170922 invullen. 
Declare @StartHiX date; Set @StartHiX= '20170101';

--Kijken of eventuele temp tables bestaan en wanneer dit het geval is droppen
Drop table if exists #TOE;
Drop table if exists #DOE;
Drop table if exists #POP;

--Mapping toediening (Toedieningsvormen)
Select	TSITNR [toedieningCodeHiX]
	,	THNM50 [toedieningHiX]
	,	case	when TSITNR = '000009' then 1
				when TSITNR = '000005' then 2
				when TSITNR = '000002' then 3
				when TSITNR = '000021' then 4
				when TSITNR = '000062' then 5
				--when TSITNR = '' then 6 --Onbekend 
				--when TSITNR = '' then 7 --Onbekend
				--when TSITNR = '' then 8 --Onbekend
				--when TSITNR = '' then 9 --Onbekend
				when TSITNR = '000078' then 10
				--when TSITNR = '' then 11 --Onbekend
				--when TSITNR = '' then 12 --Onbekend
				--when TSITNR = '' then 13 --Onbekend
				--when TSITNR = '' then 14 --Onbekend
				when TSITNR = '000010' then 15
				when TSITNR = '000006' then 16
				--when TSITNR = '' then 17 --Onbekend
				--when TSITNR = '' then 18 --Onbekend
				when TSITNR = '000115' then 19
				when TSITNR = '000054' then 20
				when TSITNR = '000053' then 21
				when TSITNR = '000055' then 22
				when TSITNR = '000038' then 23
				when TSITNR = '000074' then 24
				when TSITNR = '000011' then 25
				when TSITNR = '000007' then 26
				when TSITNR = '000012' then 27
				when TSITNR = '000058' then 28
				when TSITNR = '000121' then 29
				when TSITNR = '000008' then 30
				when TSITNR = '000034' then 31
				when TSITNR = '000041' then 32
				when TSITNR = '000059' then 33
				when TSITNR = '000063' then 34
				when TSITNR = '000050' then 35
				when TSITNR = '000110' then 36
				when TSITNR = '000075' then 37
				when TSITNR = '000128' then 38
				--when TSITNR = '' then 77 --Onbekend
				when TSITNR = '000001' then 88
				else 99 end [toedieningcodeLOGEX]
Into #TOE
From ZINDEX_902 
Where 1=1 
and ZINDEX_902.TSNR = '0007'

--Mapping dosering eenheid 
Select	convert(varchar(max),ME.CODE) [eenheidCodeHix]
	,	ME.ZOEKCODE [eenheidAfkortingHiX]
	,	ME.OMSCHR [eenheid]
	,	case	when ME.ZOEKCODE = 'AU' then 1 
				when ME.ZOEKCODE = 'AXAE' then 2
				when ME.ZOEKCODE = 'CCID' then 3
				when ME.ZOEKCODE = 'CEL' then 4
				when ME.ZOEKCODE = 'CM-2' then 5
				--when ME.ZOEKCODE = '' then 6 --Onbekend
				when ME.ZOEKCODE = 'DO' then 7
				--when ME.ZOEKCODE = '' then 8 --Onbekend
				when ME.ZOEKCODE = 'E' then 9
				when ME.ZOEKCODE = 'FIPE' then 10
				when ME.ZOEKCODE = 'GRAM' then 11
				when ME.ZOEKCODE = 'GBQ' then 12
				when ME.ZOEKCODE = 'IE' then 13
				--when ME.ZOEKCODE = '' then 14 --Onbekend
				when ME.ZOEKCODE = 'KBEQ' then 15
				when ME.ZOEKCODE = 'KIE' then 17
				when ME.ZOEKCODE = 'MBEQ' then 20
				when ME.ZOEKCODE = 'MG' then 21
				when ME.ZOEKCODE in ('ME-E','MIE') then 22
				when ME.ZOEKCODE = 'ME' then 23
				when ME.ZOEKCODE = 'MPFU' then 24 
				when ME.ZOEKCODE = 'MK' then 25
				when ME.ZOEKCODE = 'ML' then 26
				when ME.ZOEKCODE = 'MM2' then 27
				when ME.ZOEKCODE = 'MMOL' then 28
				when ME.ZOEKCODE = 'NVT' then 29
				when ME.ZOEKCODE = 'PFU' then 30
				when ME.ZOEKCODE = 'STUK' then 31
				when ME.ZOEKCODE = 'TB-E' then 32
				when ME.ZOEKCODE = 'UG' then 33
				when ME.ZOEKCODE = 'UL' then 34
				when ME.ZOEKCODE = 'USPE' then 35
				when ME.ZOEKCODE = 'VERP' then 36
				--when ME.ZOEKCODE = '' then 37 --Onbekend
				when ME.ZOEKCODE = 'DRUP' then 38
				when ME.ZOEKCODE = 'CM' then 39
				else 99 end [eenheidCodeLOGEX]
Into #DOE
From MEDICAT_EENHEID [ME]
Where 1=1 
and Verval = 0 
and ZOEKCODE <> ''

--EVS_DICAGeneesmiddelen_Reuma
Select	D.DBCNUMMER [DBCnummer]
	,	D.EPISODE [Episode]
	,	E.PATIENTNR [Patientnummer]
	,	D.HOOFDDIAG [Diagnosecode]
	,	D.BEGINDAT [DBC_Begindatum]
	,	D.EINDDAT [DBC_Einddatum]
	,	E.BEGINDAT [Episode_Begindatum]
	,	E.EINDDAT [Episode_Einddatum]
Into #POP
From EPISODE_DBCPER [D]
Left join EPISODE_EPISODE [E] on E.EPISODE = D.EPISODE
Left join PATIENT_PATIENT [P] on P.PATIENTNR = E.PATIENTNR
Where 1=1 
and D.VERVALLEN = 0 
and D.[STATUS] <> 'X'
and D.BEGINDAT <= convert(date,getdate())
and (D.EINDDAT is null or D.EINDDAT >=  iif(@StartHiX <= '20170101','20170101',@StartHiX))
and (	(D.SPECIALISM = 'PLA' /*304*/ and D.HOOFDDIAG in ('383','384','386'))
		or
		(D.SPECIALISM = 'ORT' /*305*/ and D.HOOFDDIAG in ('1052','1394','1680'))
		or
		(D.SPECIALISM = 'INT' /*313*/ and D.HOOFDDIAG in ('505','512','513','515','521'))
		or 
		(D.SPECIALISM = 'REU' /*324*/ and D.HOOFDDIAG in ('101','102','103','104','105','106','107','112','113','201','202','203','605','801'))
		or 
		(D.SPECIALISM = 'REV' /*327*/ and D.HOOFDDIAG in ('0117'))
		or 
		(D.SPECIALISM = 'OGK' /*8418*/ and D.HOOFDDIAG in ('508'))
	)
and ((convert(int,convert(char(8),D.BEGINDAT,112))-convert(char(8),P.GEBDAT,112))/10000) >= 18 
and P.PATCODES not like '%T%' 

/*
	EVS_DICAGeneesmiddelen_Reuma 
	Naamgeving:		Datum_NaamInstelling_NaamPopulatie (Bijvoorbeeld: 20210416_ASz_EVS_DICAGeneesmiddelen_Reuma)
	Bestandtype:	csv.
*/
Select	@ID [id]
	,	MR.PATIENTNR [upn]
	,	case	when Nullif(MC.ZNDXART,'') is not null and ((try_convert(int,MC.ZNDXART) not between 12900000 and 12999999) and (try_convert(int,MC.ZNDXART) not between 90000000 and 99999999)) then 1 
				when Nullif(MC.ZNDXHPK,'') is not null and (try_convert(int,MC.ZNDXHPK) not between 90000000 and 99999999) then 2 
				when Nullif(MC.ZNDXPRK,'') is not null and (try_convert(int,MC.ZNDXPRK) not between 90000000 and 99999999) then 3 
				when Nullif(MC.ZNDXGPK,'') is not null and (try_convert(int,MC.ZNDXGPK) not between 90000000 and 99999999) then 4 
				when Nullif(MC.ATCCODE,'') is not null and len(MC.ATCCODE) = 7 then 5 
				else 6 end [type-gstandard]
	,	case	when Nullif(MC.ZNDXART,'') is not null and ((try_convert(int,MC.ZNDXART) not between 12900000 and 12999999) and (try_convert(int,MC.ZNDXART) not between 90000000 and 99999999)) then convert(varchar(8),MC.ZNDXART)
				when Nullif(MC.ZNDXHPK,'') is not null and (try_convert(int,MC.ZNDXHPK) not between 90000000 and 99999999) then convert(varchar(8),MC.ZNDXHPK)
				when Nullif(MC.ZNDXPRK,'') is not null and (try_convert(int,MC.ZNDXPRK) not between 90000000 and 99999999) then convert(varchar(8),MC.ZNDXPRK)
				when Nullif(MC.ZNDXGPK,'') is not null and (try_convert(int,MC.ZNDXGPK) not between 90000000 and 99999999) then convert(varchar(8),MC.ZNDXGPK)
				when Nullif(MC.ATCCODE,'') is not null and len(MC.ATCCODE) = 7 then convert(varchar(7),MC.ATCCODE)
				else convert(varchar(51),ATC.ATOMS) end [value-gstandard]
	,	left(isnull(MR.MEDICOMS,''),100) [product]
	,	right(isnull(MR.IDENTIF,''),24) [voorschrift-identifier]
	,	right(isnull(MR.SuperPrescriptionCode,''),24) [hoofd-voorschrift-identifier]
	,	format(	isnull(convert(datetime,MS.STARTDAT + MS.STARTTIJD),convert(date,'19000101')),'yyyy-MM-dd HH:mm') [datstart]
	,	format(	case	when MS.EINDTIJD = '' and isnull(MS.EINDDAT, MR.ACTSTOPDT) is not null then convert(datetime,isnull(MS.EINDDAT, MR.ACTSTOPDT) + convert(datetime,'23:59'))
						else isnull(isnull(convert(datetime,MS.EINDDAT + MS.EINDTIJD), MR.ACTSTOPDT),convert(date,'29991231')) end ,'yyyy-MM-dd HH:mm') [datstop]
	,	case	when MS.ZONOGIG = 1 then 41
				when MS.DOSISE = '' then 88
				when MS.DOSISE = 'CS00000008' /*Keer*/ then 
						case	when MS.DOSISA = 1 then 38
								else 77 end 
				when MS.DOSISE = 'CS00000010' /*Uur*/ then 
						case	when MS.DOSISA = 1 then 1 
								else 77 end
				when MS.DOSISE = 'CS00000011' /*Dag*/ then 
						case	when MS.DOSISA = 1 then 4 
								when MS.DOSISA = 2 then 5
								when MS.DOSISA = 3 then 6
								when MS.DOSISA = 4 then 7
								when MS.DOSISA = 5 then 8
								when MS.DOSISA = 6 then 9
								when MS.DOSISA = 7 then 10
								when MS.DOSISA = 8 then 11
								when MS.DOSISA = 9 then 12
								when MS.DOSISA = 10 then 13
								when MS.DOSISA = 11 then 14
								when MS.DOSISA = 12 then 15
								Else 77	end 
				When MS.DOSISE = 'CS00000012' /*Week*/ then 
						case	when MS.DOSISA = 1 then 25
								when MS.DOSISA = 2 then 26
								when MS.DOSISA = 3 then 27
								when MS.DOSISA = 4 then 28
								when MS.DOSISA = 5 then 29
								when MS.DOSISA = 6 then 30
								else 77 end 
				when MS.DOSISE = 'CS00000013' /*Maand*/ then 
						case	when MS.DOSISA in (0,1) then 36
								else 77 end 
				when MS.DOSISE = 'CS00000014' /*Jaar*/ then 77
				Else 99 end [frequentie1]
	,	left(replace(isnull(MR.SCHEMAOMS,''),',','.'),50) [frequentie2]
	,	replace(isnull(MS.HOEVEELHA,''),',','.') [aantal-eh]
	,	isnull(DOE.eenheidCodeLOGEX,99) [eenheid]
	,	left(isnull(concat(MC.STERKHOEV,' ',Lower(SHU.ZOEKCODE)),''),50) [concentratie]
	,	isnull(TOE.toedieningcodeLOGEX,99) [toediening]
	,	left(iif(TOE.toedieningcodeLOGEX = 99,TOH.THNM50,''),40) [toediening-anders]
	,	left(case	when SP.ZORGVSOORT = '03' then SP.ZORGVSOORT + RIGHT('00'+isnull(convert(varchar(2),SP.COTGCODE),''),2)
					when SP.ZORGVSOORT = '11' then SP.ZORGVSOORT + RIGHT('00'+isnull(convert(varchar(2),SP.COTGCODE),''),2)
					when SP.ZORGVSOORT = '84' then SP.ZORGVSOORT + RIGHT('00'+isnull(convert(varchar(2),SP.COTGCODE),''),2)
					else '0300' end 
			,4) [agb]
	,	case	when MR.VRSCHRTYP = 'K'  then 1
				when MR.VRSCHRTYP = 'P'	 then 2 
				else 9 end [voorschrift-type]
	,	1 [voorschrift-bron]
	,	99 [indicatie1]
	,	99 [indicatie2]
From MEDICAT_RECDEEL [MR]
Join MEDICAT_MEDICIJN [MC] on MC.CODE = MR.MEDCD
Join MEDICAT_SCHEMA [MS] on MS.CODE = MR.SCHEMCD
Left join PATIENT_PATIENT [PP] on PP.PATIENTNR = MR.PATIENTNR
Left join CSZISLIB_ARTS [CA] on CA.ARTSCODE = MR.AANVRCODE
Left join CSZISLIB_SPEC [SP] on SP.SPECCODE = CA.SPECIALISM
Left join MEDICAT_EENHEID [ME_C] on ME_C.CODE = MS.HOEVEELHE and ME_C.VERVAL = 0 
Left join MEDICAT_EENHEID [SHU] on SHU.CODE = MC.STERKEHC
Left join #TOE [TOE] on TOE.toedieningCodeHiX = MR.TOEDCD
Left join #DOE [DOE] on DOE.eenheidCodeHix = MS.HOEVEELHE
Left join ZINDEX_902 [TOH] on TOH.TSITNR = MR.TOEDCD and TOH.TSNR = '0007'
Left join ZINDEX_801 [ATC] on ATC.ATCODE = MC.ATCCODE
Outer apply (	Select top 1 * 
				From #POP [P]
				Where 1=1 
				and P.Patientnummer = MR.PATIENTNR
				and P.DBC_Begindatum <= isnull(MR.ACTSTOPDT,getdate())
				and (P.DBC_Einddatum >= MR.VRSCHRDAT or P.DBC_Einddatum is null)
				Order by 
				P.DBCnummer
			) EPI 
Where 1=1 
and PP.PATCODES not like '%T%'
and MR.VRSCHRTYP <> 'R'
and MR.VRSCHRDAT between iif(@StartHiX <= '20170101','20170101',@StartHiX) and convert(date,getdate())
and MR.PATIENTNR in (Select P.Patientnummer From #POP [P])
and MC.ATCCODE <> ''
and (MR.ACTSTOPDT is null or (MR.ACTSTOPDT >= MR.VRSCHRDAT and MR.ACTSTOPDT >= MS.STARTDAT))
and MS.HOEVEELHA >= 0  
and MS.STARTDAT <= convert(date,getdate())
and MR.VRSCHRDAT <= convert(date,getdate())
and EPI.DBCnummer is not null 

Drop table if exists #TOE;
Drop table if exists #DOE;
Drop table if exists #POP;